'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ReactRateComponent(props) {
    var _useState = (0, _react.useState)(props.defaultValue || 0),
        _useState2 = _slicedToArray(_useState, 2),
        value = _useState2[0],
        setValue = _useState2[1];

    var _useState3 = (0, _react.useState)([]),
        _useState4 = _slicedToArray(_useState3, 2),
        symbols = _useState4[0],
        setSymbols = _useState4[1];

    var _useState5 = (0, _react.useState)(0),
        _useState6 = _slicedToArray(_useState5, 2),
        rateCount = _useState6[0],
        setRateCount = _useState6[1];

    var _useState7 = (0, _react.useState)({
        count: props.count,
        size: props.size,
        symbol: props.symbol,
        inactiveColor: props.inactiveColor,
        activeColor: props.activeColor,
        edit: props.edit
    }),
        _useState8 = _slicedToArray(_useState7, 2),
        config = _useState8[0],
        setConfig = _useState8[1];

    (0, _react.useEffect)(function () {
        setSymbols(getSymbols(value));
        window.addEventListener('onMouseOver', onMouseOver);
        window.addEventListener('onMouseLeave', mouseLeave);
        return function () {
            window.removeEventListener('onMouseOver', onMouseOver);
            window.removeEventListener('onMouseLeave', mouseLeave);
        };
    }, []);

    var getSymbols = function getSymbols(activeCount) {
        if (typeof activeCount === 'undefined') {
            activeCount = value;
        }
        var symbols = [];
        for (var i = 0; i < config.count; i++) {
            symbols.push({
                active: i <= activeCount - 1
            });
        }
        return symbols;
    };

    var onMouseOver = function onMouseOver(rateIndex) {
        if (!config.edit) return;
        rateIndex = rateIndex + 1;
        setSymbols(getSymbols(rateIndex));
        setRateCount(rateIndex);
    };

    var mouseLeave = function mouseLeave() {
        if (!config.edit) return;
        setSymbols(getSymbols());
        setRateCount(value);
    };

    function handleOnPress(rateIndex) {
        if (!config.edit) return;
        var value = rateIndex = rateIndex + 1;
        setSymbols(getSymbols(rateIndex));
        setValue(value);
        setRateCount(rateIndex);
        props.onChange(value);
    }

    return _react2.default.createElement(
        'div',
        { style: containerStyle },
        _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(RenderSymbols, { config: config, symbols: symbols, onMouseOver: onMouseOver, onMouseLeave: mouseLeave, handleOnPress: handleOnPress })
        ),
        props.showCount && rateCount !== 0 && _react2.default.createElement(
            'div',
            { style: { float: 'left', paddingLeft: (props.count - 1) * props.size / 2 + 'px' } },
            rateCount
        )
    );
}

function RenderSymbols(_ref) {
    var config = _ref.config,
        symbols = _ref.symbols,
        _onMouseOver = _ref.onMouseOver,
        onMouseLeave = _ref.onMouseLeave,
        handleOnPress = _ref.handleOnPress;
    var inactiveColor = config.inactiveColor,
        activeColor = config.activeColor,
        size = config.size,
        symbol = config.symbol,
        edit = config.edit;

    return symbols.map(function (rate_s, i) {
        var style = Object.assign({}, rateDefaultStyle, {
            color: rate_s.active ? activeColor : inactiveColor,
            cursor: edit ? 'pointer' : 'default',
            fontSize: size + 'px'
        });
        return _react2.default.createElement(
            'span',
            {
                style: style,
                key: i,
                'rate-index': i,
                onMouseOver: function onMouseOver() {
                    return _onMouseOver(i);
                },
                onMouseLeave: onMouseLeave,
                onClick: function onClick() {
                    return handleOnPress(i);
                } },
            symbol
        );
    });
}

var rateDefaultStyle = {
    position: 'relative',
    overflow: 'hidden',
    cursor: 'pointer',
    display: 'block',
    float: 'left'
};

var containerStyle = {
    overflow: 'hidden',
    position: 'relative',
    display: 'flex',
    flexDirection: 'column'
};

ReactRateComponent.propTypes = {
    edit: _propTypes2.default.bool,
    showCount: _propTypes2.default.bool,
    defaultValue: _propTypes2.default.number,
    count: _propTypes2.default.number,
    symbol: _propTypes2.default.string,
    size: _propTypes2.default.number,
    inactiveColor: _propTypes2.default.string,
    activeColor: _propTypes2.default.string
};
ReactRateComponent.defaultProps = {
    edit: true,
    showCount: false,
    defaultValue: 0,
    count: 5,
    symbol: '★',
    size: 25,
    inactiveColor: '#949494',
    activeColor: '#ffd700',
    onChange: function onChange() {}
};

exports.default = ReactRateComponent;